;*************************************************************** 
;* 
;* 8-bites timer PWM mdjt bemutat program
;* 
;* A C port gombjaival llthat a kitltsi tnyez.
;* 
;*************************************************************** 
;* 
;*  Kszitette: Aradi Szilrd
;*  Csoport:
;*  Dtum: 2012.02.10.
;* 
;*************************************************************** 
 
.include "m128def.inc"  		; ATmega128 defincis fjl
 
;*************************************************************** 
;* Konstansok 
;*************************************************************** 
.equ	OC0mask = 0x10
;*************************************************************** 
;* Vltozk
;*************************************************************** 
.def	mpr1 = R16				;  ltalnos felhasznls regiszterek

;*************************************************************** 
;* Makrk
;*************************************************************** 
.MACRO Timer0_Init ;mode, compvalue
		ldi		mpr1,@0		
		out		TCCR0,mpr1		
		ldi		mpr1,@1		
		out		OCR0,mpr1		
		in		mpr1,TIMSK
	;	ori		mpr1,1<<OCIE0	;Timer0 OC IT enabled ;nincs szksg timer interruptra
	;	out		TIMSK,mpr1
.ENDMACRO

;*************************************************************** 
;* Megszakts vektorok
;*************************************************************** 
.cseg 
.org 0x0000      				; Kdszegmens kezdcme

		jmp	init				; Reset vektor
	
;*****************************************************************************
;* Inicializls
;*****************************************************************************

;***** Stack inicializlsa *****

init:	ldi		mpr1,LOW(RAMEND)	; RAMEND = RAM vgcme
		out		SPL,mpr1			; (ld."m128def.inc") 
		ldi		mpr1,HIGH(RAMEND)
		out		SPH,mpr1

;*****************************************************************************
;* Fprogram
;*****************************************************************************		

main:
		ldi		mpr1,OC0mask
		out		DDRB,mpr1
		ldi		mpr1,0xFF
		out		PORTD,mpr1

		; 1024 prescaler, CTC mode (clear on compare match) OC0 disconnected
		; TCCR0: FC0 WGM00 COM01 CM00 WGM01 CS02 CS01 CS00
		;         0    1    1     0     0     0    1    0
		; f = 8MHz/(8*510) = 1960.78 Hz 
		TIMER0_Init 0x62,127
		sei

loop:	in		mpr1,PIND
		out		OCR0,mpr1
		jmp		loop;			; Vgtelen hurok
		
;*****************************************************************************
;* Szubrutinok
;*****************************************************************************

;*****************************************************************************
;* Megszakts kezel rutinok
;*****************************************************************************

;*****************************************************************************
;* Adatok
;*****************************************************************************
